/*------------------------------------------------------------------------------
 Copyright:      Radig Ulrich  mailto: mail@ulrichradig.de
 Author:         Radig Ulrich
 Remarks:        
 known Problems: none
 Version:        24.10.2007
 Description:    Commando Interpreter
------------------------------------------------------------------------------*/

#ifndef _CMD_H_
	#define _CMD_H_	
		
	//----------------------------------------------------------------------------
	#include <avr/io.h>
	#include <string.h>
	#include <stdlib.h>
	#include <avr/eeprom.h>
	#include "usart.h"
	#include "stack.h"
	#include "httpd.h"
	#include "ntp.h"
	
	//----------------------------------------------------------------------------	
	typedef struct
	{
		char* cmd; 				// Stringzeiger auf Befehlsnamen
		void(*fp)(void);  		// Zeiger auf auszufhrende Funktion
		char* helptext;
	} CMD_ITEM;	
	
	#define MAX_VAR	6
	
	unsigned char cmd_exec(char *pstr);
	void write_eeprom_ip (unsigned int eeprom_adresse);
	
	//reset the unit
	void command_reset	(void);
	//Ausgabe der ARP Tabelle
	void command_arp 	(void);
	//Ausgabe der TCP Tabelle
	void command_tcp 	(void);
	
	//ndern/ausgabe der IP, NETMASK, ROUTER_IP, NTP_IP
	void command_ip 	(void);
	void command_net 	(void);
	void command_router	(void);
	void command_ntp 	(void);

	void command_mac	(void);
	void command_ver	(void);
	void command_setvar	(void);
	void command_time	(void);
	void command_help 	(void);
	
	#define RESET() {asm("ldi r30,0"); asm("ldi r31,0"); asm("ijmp");}
	
#endif //_CMD_H_


